// editor.cpp
// strip resource data from DTA files (save10.dta)
// by shaktazuki
// Fixed by Artlav

#define type(x) ((x > 0x80 && x < 0x91)?LTGRAY:(x > 0x40 && x < 0x51)?LTYELLOW:(x > 0x20 && x < 0x31)?LTGREEN:BLUE)
#define BMP_DIM 112 // should be a multiple of 112, we will have an array with the x dimension half this value

#include <fstream>
#include <iostream>
#include "bmp16.h"
using namespace std;

int main(int argc, char argv[])
{
 char in;
 ifstream infile("save4.hot"); 
 char filename[]="resource.bmp";
 unsigned char bmpdata[BMP_DIM][BMP_DIM/2];
 
 //Initialize bmpdata
 for(int i=0; i<BMP_DIM; i++) for(int j=0; j<BMP_DIM/2; j++) bmpdata[i][j]=0;

 if(!infile){
  cout << "Could not open save4.hot." << endl;
  cin.get();
  return -1;
 }

 //Offset in decimal of resource map in the DTA file
 infile.seekg(12768); //1.04
 //infile.seekg(12763); //1.56

 for(int i=0; i<112 && infile.tellg()<=37854; i++){
  for(int j=0; j<112 && infile.tellg()<=37854; j++){

   infile.get(in);  //Read the resource byte
   infile.ignore(); //Ignore the visibility bitmask

   if(j % 2){  // if i is odd
    bmpdata[BMP_DIM-1-i][j/2] |= type((unsigned char)in); // set the low bits
   }else{
    bmpdata[BMP_DIM-1-i][j/2] |= type((unsigned char)in) << 4; // set the high bits
   }

  }
 }
 infile.close();
 writebmp16(filename,BMP_DIM,BMP_DIM,(unsigned char *)&bmpdata);
 return 0;
}

